#!/usr/bin/perl

use strict;
use warnings;
use JSON;
local $ENV{PATH} = "/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin";

    my $dir = 'upload/';
    my $conf = {
           input    => $dir . 'demo.mp4',
           json     => $dir . 'video.json',
           capture  => $dir . 'capture',
           log      => $dir . 'capture.log',
           callback => 'progress.pl'
       };

    my $hash = { url => $conf->{callback} };

    mkdir($conf->{capture});
    my $wh = &write_json();
    `ffmpeg -i $conf->{input} -r 1 -s $wh $conf->{capture}/%05d.jpg >/dev/null 2> $conf->{log} &`;

    print "Content-type: application/json; charset=utf-8\n";
    print "X-Content-Type-Options: nosniff\n\n";
    print to_json($hash);

sub write_json {

    my $data = '';
    my $wh = '';

    my @data = `ffprobe -show_streams -print_format json $conf->{input} 2>/dev/null`;
    chomp(@data);

    foreach (@data) {
        $_ =~ s/\s//g;
        $data .= $_;
    }

    $data = from_json($data);

    if (defined(@{$data->{streams}}[0]->{width}) && defined(@{$data->{streams}}[0]->{height})) {
        $wh = @{$data->{streams}}[0]->{width} . 'x' . @{$data->{streams}}[0]->{height};
    } elsif (defined(@{$data->{streams}}[1]->{width}) && defined(@{$data->{streams}}[1]->{height})) {
        $wh = @{$data->{streams}}[1]->{width} . 'x' . @{$data->{streams}}[1]->{height};
    } else {
        $wh = '640x360';
    }

    $data = to_json($data);

    open(OUT, "> $conf->{json}");
    print OUT $data;
    close(OUT);

    return($wh);

}
