/*
 * Video.js for IE
 */
var ua = navigator.userAgent.toLowerCase();
var isIE = (ua.indexOf('msie') > -1) && (ua.indexOf('opera') == -1) || (ua.indexOf('trident/7') > -1);                                
if (isIE) {
	videojs.options.hls.mode = 'flash';
} 

/*
 * Video.js logobrand
 * https://github.com/Mewte/videojs-logobrand
 *
 * Copyright (c) 2014 Mewte @ InstaSynch
 * Licensed under the MIT license
 */
(function(vjs) {

	var defaults = {
		image: '',
		destination: '#'
	};

	var logobrand = function(options) {
		var settings = videojs.mergeOptions(defaults, options), player = this;
		var link = document.createElement("a");
			link.id = "vjs-logobrand-image-destination";
			link.href = settings.destination;
			link.target = "_blank";
		var image = document.createElement('img');
			image.id = 'vjs-logobrand-image';
			image.src = settings.image;
		link.appendChild(image);
		player.el().appendChild(link);
		
		this.loadImage = function(src){
			document.getElementById("vjs-logobrand-image").src=src;
		};
		this.setDestination = function(href){
			document.getElementById("vjs-logobrand-image-destination").href = href;
		};
		return this;
	};	

	vjs.plugin('logobrand', logobrand);

}(window.videojs));

/* videojs thumbnails */
(function () {
	var capture_sec = 5;
	var defaults = {}, extend = function () {
		var args, target, i, object, property;
		args = Array.prototype.slice.call(arguments);
		target = args.shift() || {};
		for (i in args) {
			object = args[i];
			for (property in object) {
				if (object.hasOwnProperty(property)) {
					if (typeof object[property] === 'object') {
						target[property] = extend(target[property], object[property]);
					} else {
						target[property] = object[property];
					}
				}
			}
		}
		return target;
	},
	getComputedStyle = function (el, pseudo) {
		return function (prop) {
			if (window.getComputedStyle) {
				return window.getComputedStyle(el, pseudo)[prop];
			} else {
				return el.currentStyle[prop];
			}
		};
	},
	offsetParent = function (el) {
		if (el.nodeName !== 'HTML' && getComputedStyle(el)('position') === 'static') {
			return offsetParent(el.offsetParent);
		}
		return el;
	},
	getVisibleWidth = function (el, width) {
		var clip;
		if (width) {
			return parseFloat(width);
		}
		clip = getComputedStyle(el)('clip');
		if (clip !== 'auto' && clip !== 'inherit') {
			clip = clip.split(/(?:\(|\))/)[1].split(/(?:,| )/);
			if (clip.length === 4) {
				return (parseFloat(clip[1]) - parseFloat(clip[3]));
			}
		}
		return 0;
	},
	getScrollOffset  = function () {
		if (window.pageXOffset) {
			return {x: window.pageXOffset, y: window.pageYOffset};
		}
		return {x: document.documentElement.scrollLeft, y: document.documentElement.scrollTop};
	};
	videojs.plugin('thumbnails', function (options) {
		var div, settings, img, player, progressControl, duration, moveListener, moveCancel;
		settings = extend({}, defaults, options);
		player = this;
		allcapture = settings.src||null;
		(function () {
			var progressControl, addFakeActive, removeFakeActive;
			if (navigator.userAgent.toLowerCase().indexOf("android") !== -1) {
				progressControl = player.controlBar.progressControl;
				addFakeActive = function () {
					progressControl.addClass('fake-active');
				};
				removeFakeActive = function () {
					progressControl.removeClass('fake-active');
				};
				progressControl.on('touchstart', addFakeActive);
				progressControl.on('touchend', removeFakeActive);
				progressControl.on('touchcancel', removeFakeActive);
			}
		})();
		if (allcapture === null) {
			return false;
		}
		div = document.createElement('div');
		div.className = 'vjs-thumbnail-holder';
		$(div).css('background-image', 'url(' + allcapture + ')')
		duration = player.duration();
		player.on('durationchange', function (event) {
			duration = player.duration();
		});
		player.on('loadedmetadata', function (event) {
			duration = player.duration();
		});
		progressControl = player.controlBar.progressControl;
		progressControl.el().appendChild(div);
		moveListener = function (event) {
			var mouseTime, time, active, left, setting, pageX, right, width, halfWidth, pageXOffset, clientRect;
			active = 0;
			pageXOffset = getScrollOffset().x;
			clientRect = offsetParent(progressControl.el()).getBoundingClientRect();
			right = (clientRect.width || clientRect.right) + pageXOffset;
			pageX = event.pageX;
			if (event.changedTouches) {
				pageX = event.changedTouches[0].pageX;
			}
			left = pageX || (event.clientX + document.body.scrollLeft + document.documentElement.scrollLeft);
			left -= offsetParent(progressControl.el()).getBoundingClientRect().left + pageXOffset;
			left_pos = $(progressControl.el()).offset().left;
			progress_width = $(progressControl.el()).width();
			percent_pos = (event.clientX - left_pos) / progress_width;
			thumb_width = Math.floor(duration / capture_sec) * 120;
			thumb_num = Math.floor(duration * percent_pos / capture_sec);
			thumb_position = thumb_width - thumb_num * 120;
			if (thumb_position < 120) {
				thumb_position = 120;
			}
			if (thumb_position > thumb_width) {
				thumb_position = thumb_width;
			}
			$(div).css({
				"background-position": thumb_position + "px 0"
			})
			if (left < 60) {
				left = 60
			}
			if (left > progress_width - 60) {
				left = progress_width - 60
			}
			div.style.left = left - 60 + 'px';
		};
		progressControl.on('mousemove', moveListener);
		progressControl.on('touchmove', moveListener);
		moveCancel = function (event) {
			div.style.left = '-1000px';
		};
		progressControl.on('mouseout', moveCancel);
		progressControl.on('touchcancel', moveCancel);
		progressControl.on('touchend', moveCancel);
		player.on('userinactive', moveCancel);
	});
})();
